; Script generated by the HM NIS Edit Script Wizard.
;ENVIRONMENT VARIABLES
!define VTKBINDIR "vtk-5.4.2-install\bin"
!define VTKINCDIR "vtk-5.4.2-install\include\vtk-5.4"
!define VTKLIBDIR "vtk-5.4.2-install\lib\vtk-5.4"
!define QWTINCDIR "Qwt-5.3.0-svn\include"
!define QWTLIBDIR "Qwt-5.3.0-svn\lib"
!define QWTPLOT3DINCDIR "qwtplot3d\include"
!define QWTPLOT3DLIBDIR "qwtplot3d\lib"

;SOURCE_PATHS
!define EXAMPLES_SOURCE_PATH "Libraries\Examples"
!define VTK_SOURCE_PATH "Libraries\vtk-5.4.2-install"
!define QWT_SOURCE_PATH "Libraries\Qwt-5.3.0-svn"
!define QWTPLOT3D_SOURCE_PATH "Libraries\qwtplot3d"
!define PLUGINS_SOURCE_PATH "Plugins"

;DESTINATION PATHS
!define EXAMPLES_DEST_PATH "$INSTDIR\Examples"
!define VTK_DEST_PATH "$INSTDIR\vtk-5.4.2-install"
!define QWT_DEST_PATH "$INSTDIR\Qwt-5.3.0-svn"
!define QWTPLOT3D_DEST_PATH "$INSTDIR\qwtplot3d"
!define PLUGINS_DEST_PATH "C:\Qt\2009.03\qt\plugins\designer"

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "enGits Development Environment"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "enGits GmbH"
!define PRODUCT_WEB_SITE "http://www.engits.com"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"
!include "EnvVarUpdate.nsh"
; HKLM (all users) vs HKCU (current user) defines
!define env_hklm 'HKLM "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"'
!define env_hkcu 'HKCU "Environment"'

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "license.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "SetupEnGitsDevelopmentEnvironment.exe"
InstallDir "C:\Libraries"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "VTK" SEC01
  SetOverwrite try
  CreateDirectory "$SMPROGRAMS\enGits Development Environment"

    ;VTK_INSTALL_LIST
    !include "install_VTK.nsh"

  ;VTK ENVIRONMENT SETUP
   ; include for some of the windows messages defines
   !include "winmessages.nsh"
   ; set variable
   WriteRegExpandStr ${env_hklm} VTKBINDIR "$INSTDIR\${VTKBINDIR}"
   WriteRegExpandStr ${env_hklm} VTKINCDIR "$INSTDIR\${VTKINCDIR}"
   WriteRegExpandStr ${env_hklm} VTKLIBDIR "$INSTDIR\${VTKLIBDIR}"
   ; make sure windows knows about the change
   SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

   ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\${VTKBINDIR}" ; Append

SectionEnd

Section "Qwt" SEC02
  SetOverwrite try
  CreateDirectory "$SMPROGRAMS\enGits Development Environment"

    ;QWT_INSTALL_LIST
    !include "install_Qwt.nsh"

  ;QWT ENVIRONMENT SETUP
     ; include for some of the windows messages defines
   !include "winmessages.nsh"
   ; set variable
   WriteRegExpandStr ${env_hklm} QWTINCDIR "$INSTDIR\${QWTINCDIR}"
   WriteRegExpandStr ${env_hklm} QWTLIBDIR "$INSTDIR\${QWTLIBDIR}"
   ; make sure windows knows about the change
   SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

   ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\${QWTLIBDIR}" ; Append

SectionEnd

Section "QwtPlot3D" SEC03
  SetOverwrite try
  CreateDirectory "$SMPROGRAMS\enGits Development Environment"

    ;QWTPLOT3D_INSTALL_LIST
    !include "install_QwtPlot3D.nsh"

  ;QWTPLOT3D ENVIRONMENT SETUP
     ; include for some of the windows messages defines
   !include "winmessages.nsh"
   ; set variable
   WriteRegExpandStr ${env_hklm} QWTPLOT3DINCDIR "$INSTDIR\${QWTPLOT3DINCDIR}"
   WriteRegExpandStr ${env_hklm} QWTPLOT3DLIBDIR "$INSTDIR\${QWTPLOT3DLIBDIR}"
   ; make sure windows knows about the change
   SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

   ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\${QWTPLOT3DLIBDIR}" ; Append

SectionEnd

Section "Examples" SEC04
  ;EXAMPLES_INSTALL_LIST
  !include "install_examples.nsh"
SectionEnd

Section "Plugins" SEC05
  ;PLUGINS_INSTALL_LIST
  !include "install_Plugins.nsh"
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\enGits Development Environment\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\enGits Development Environment\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} ""
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} ""
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} ""
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} ""
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC05} ""
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  ;UNINSTALL_LISTS
  !include "uninstall_examples.nsh"
  !include "uninstall_VTK.nsh"
  !include "uninstall_Qwt.nsh"
  !include "uninstall_QwtPlot3D.nsh"
  !include "uninstall_Plugins.nsh"

  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$SMPROGRAMS\enGits Development Environment\Uninstall.lnk"
  Delete "$SMPROGRAMS\enGits Development Environment\Website.lnk"

  RMDir "C:\Qt\2009.03\qt\plugins\designer"
  RMDir "$SMPROGRAMS\enGits Development Environment"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true

  ;CLEAN UP ENVIRONMENT
   ; delete variable
   DeleteRegValue ${env_hklm} VTKBINDIR
   DeleteRegValue ${env_hklm} VTKINCDIR
   DeleteRegValue ${env_hklm} VTKLIBDIR
   DeleteRegValue ${env_hklm} QWTINCDIR
   DeleteRegValue ${env_hklm} QWTLIBDIR
   DeleteRegValue ${env_hklm} QWTPLOT3DINCDIR
   DeleteRegValue ${env_hklm} QWTPLOT3DLIBDIR
   ; make sure windows knows about the change
   SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000

   ${un.EnvVarUpdate} $0 "PATH" "R" "HKLM" "$INSTDIR\${VTKBINDIR}"
   ${un.EnvVarUpdate} $0 "PATH" "R" "HKLM" "$INSTDIR\${QWTLIBDIR}"
   ${un.EnvVarUpdate} $0 "PATH" "R" "HKLM" "$INSTDIR\${QWTPLOT3DLIBDIR}"

SectionEnd
